const express = require('express');
const jsonFile = require('jsonfile');

const app = express();
app.use(express.json());
app.use(express.urlencoded());


//GET REQUEST - READ - GET ALL
app.get('/',(req,res) =>{
  res.sendFile('./database.json' ,{root: __dirname} )
})


//GET REQUEST - READ - GET BY ID
app.get('/:id', (req,res) =>{
    // console.log(req.params.id);
    jsonFile.readFile('./database.json',(err, data)=> {
        res.send(data.find( ele => ele.id == req.params.id));
    })
})


app.post('/', (req,res) =>{
    jsonFile.readFile('./database.json',(err,data) => {
        if(err){
            console.log(err)
        }
        else{
            data.push(req.body);
            jsonFile.writeFile('./database.json', data , (err) => {
              err? console.log(err) : console.log('file updated');
            });
        }
    })

})


app.put('/', (req,res) =>{
    jsonFile.readFile('./database.json', (err,data) =>{
        if(err){
            console.log(err)
        }
        else{
            var newData = data.map((ele) =>{
                if(ele.id == req.body.id){
                    ele.name = req.body.name;
                    return ele;
                }
                else{
                    return ele;
                }
            })

            jsonFile.writeFile('./database.json', newData,  (err) =>{
                if(err){
                    console.log(err)
                }
                else{
                    console.log(newData);
                }
            })
        }
    })
})

app.delete('/', (req,res) => {
    jsonFile.readFile('./database.json', (err,data) => {
        if(err){
            console.log(err)
        }
        else{
          data.splice(data.findIndex((ele)=>  ele.id == req.body.id), 1);
           jsonFile.writeFile('./database.json',data  , (err) =>{
            if(err){
                console.log(err)
            }
            else{
                console.log(`ITEM ${req.body.id} deleted!`);
            }
           })
        }
    })
})












app.listen(3000);